/* window.vala
 *
 * Copyright 2022 Michał Rudowicz
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace Hamlocator {
    public delegate void TriggerRefreshFunc();

    [GtkTemplate (ui = "/eu/fl9/hamlocator/window.ui")]
    public class Window : Gtk.ApplicationWindow {
        [GtkChild]
        private unowned Gtk.Label label;
        [GtkChild]
        private unowned Gtk.Label label_details;
        [GtkChild]
        private unowned Gtk.Button refresh_btn;

        public Window (Gtk.Application app, TriggerRefreshFunc trigger_refresh) {
            Object (application: app);
            refresh_btn.clicked.connect(() => { trigger_refresh(); });
        }

        public void SetLabel(string text) {
            label.label = text;
        }

        public void SetDetails(string text) {
            label_details.label = text;
        }

        public void SetRefreshButtonEnabled(bool e) {
            refresh_btn.sensitive = e;
        }
    }
}
